<template>
  <!-- 搜索工作栏 -->
  <ContentWrap>
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="100px"
    >
<!--      <el-form-item label="挂锁类型编码" prop="lockTypeCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.lockTypeCode"-->
<!--          placeholder="请输入挂锁类型编码"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="挂锁类型名称" prop="lockTypeName">
        <el-input
          v-model="queryParams.lockTypeName"
          placeholder="请输入挂锁类型名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"> <Icon icon="ep:search" class="mr-5px" /> 搜索 </el-button>
        <el-button @click="resetQuery"> <Icon icon="ep:refresh" class="mr-5px" /> 重置 </el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['mes:md:locktype:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button type="danger" plain @click="toggleExpandAll">
          <Icon icon="ep:sort" class="mr-5px" /> 展开/折叠
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table
      v-loading="loading"
      :data="list"
      row-key="id"
      :default-expand-all="isExpandAll"
      v-if="refreshTable"
      :tree-props="{ children: 'children', hasChildren: 'hasChildren' }"
    >
<!--      <el-table-column prop="lockTypeCode" label="挂锁类型编码" width="260" align="center" />-->
      <el-table-column prop="lockTypeName" label="挂锁类型名称"  align="center" />
      <el-table-column label="挂锁类型图标"  align="center">
        <template #default="{ row }">
          <el-image
            v-if="row.lockTypeIcon"
            :src="row.lockTypeIcon"
            style="width: 50px; height: 50px"
          />
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="挂锁类型图片"  align="center">
        <template #default="{ row }">
          <el-image
            v-if="row.lockTypeImg"
            :src="row.lockTypeImg"
            style="width: 50px; height: 50px"
          />
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column prop="lockTypeSpec" label="挂锁型号"  align="center" />
      <el-table-column label="操作" align="center" >
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['mes:md:locktype:update']"
          >
            修改
          </el-button>
          <el-button
            link
            type="primary"
            @click="openForm('create',undefined, scope.row.id)"
            v-hasPermi="['mes:md:locktype:create']"
          >
            新增
          </el-button>
          <el-button
            v-if="scope.row.parentTypeId !== 0"
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['mes:md:locktype:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <padLockTypeForm ref="formRef" @success="getList" />
</template>

<script lang="ts" setup>
import { handleTree } from '@/utils/tree'
import * as padLockTypeApi from '@/api/hw/type/padLockType/index'
import padLockTypeForm from './padLockTypeForm.vue'

defineOptions({ name: 'LockType' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref() // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: -1,
  lockTypeCode: undefined,
  lockTypeName: undefined,
  lockTypeId: undefined
})
const queryFormRef = ref() // 搜索的表单
const isExpandAll = ref(true) // 是否展开，默认全部展开
const refreshTable = ref(true) // 重新渲染表格状态

/** 查询挂锁类型列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await padLockTypeApi.listpadLockTypeApi(queryParams)
    list.value = handleTree(data.list, 'id', 'parentTypeId')
  } finally {
    loading.value = false
  }
}

/** 展开/折叠操作 */
const toggleExpandAll = () => {
  refreshTable.value = false
  isExpandAll.value = !isExpandAll.value
  nextTick(() => {
    refreshTable.value = true
  })
}

/** 搜索按钮操作 */
const handleQuery = () => {
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryParams.pageNo = 1
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number,parentTypeId?:number) => {
  formRef.value.open(type, id,parentTypeId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    await message.confirm('是否确认删除该挂锁类型？')
    await padLockTypeApi.delpadLockTypeApi(id)
    message.success(t('common.delSuccess'))
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(async () => {
  await getList()
})
</script>
